import 'dart:async';

import 'package:flutter/services.dart';

class AppconsentTv {
  static const MethodChannel _channel = MethodChannel('appconsent_tv');

  /// Setup the AppConsent SDK
  static Future<void> setup(
          String appKey, bool forceApplyGDPR, bool forceATT) async =>
      await _channel.invokeMethod("setup", {
        "appKey": appKey,
        "forceApplyGDPR": forceApplyGDPR,
        "forceATT": forceATT
      });

  /// Present the Notice if needed
  static Future<void> presentNotice(bool force) async {
    await _channel.invokeMethod("presentNotice", {"force": force});
  }

  /// Clear user consent, this only clears local consent in UserDefaults, not on server
  static Future<void> clearConsent() async {
    await _channel.invokeMethod('clearConsent');
  }

  /// Check if consent was given
  static Future<bool> get consentGiven async {
    final bool result = await _channel.invokeMethod('consentGiven');
    return result;
  }
}
